# Nulla

An agnostic social network following the KISS and UNIX philosophy, the main principles of which are minimalism and rationalism. It implements the ActivityPub protocol and promises maximum compatibility with all existing implementations.

## TODO

Stack: Elixir + Phoenix + PostgreSQL

- [ ] Lightweight web interface
- [ ] API compatible with other ActivityPub instances
- [ ] JWT
- [ ] Groups
- [ ] Formatting: big/medium/small title, bold, italic, strikethrough, link, code, code block
- [ ] Links preview
- [ ] Timelines: Home / Local / Global / Custom
- [ ] Global search
- [ ] Bookmarks
- [ ] Profile links verification
- [ ] Links preview
- [ ] Import/Export posts
- [x] Sync user settings on the server
- [ ] Restricted direct messages
- [ ] Direct messages tab

### Server configuration

* Disk space limit per user
* Limit on posts (count/time)

### User settings

#### Profile

* Avatar
* Banner
* Name
* Bio
* Location
* Birthday
* Links
* Follow requests approval
* Toggle reacts under own posts
* Toggle view of reacts under posts
* Profile migration
* Delete account

===== Disk Usage: 100 MB (20%) =====

#### Security

* Change password
* Token
* Enable/Disable email login notifications
* Sessions

| IP              | Datetime            | Action |
| ----------------|---------------------|--------|
| 127.0.0.1       | 2025-01-01 00:00:00 | revoke |
| 127.127.127.127 | 2025-02-02 00:00:00 | revoke |

#### Filters

* Placeholder with rules

```
filter keyword #tag user@example.com example.com
```

* Show replies of all followed users
* Show replies of this followed users

## Contributing

### Patches via Email

You can create a patch with this command `git format-patch -M origin/main` and send it to this [email address](mailto:miraikumiko@disroot.org). Check out this [guide](https://git-send-email.io).

### Your repository

You fork this repository and make your changes in the feature branch, then I pull it.
