defmodule Nulla.Repo.Migrations.CreateActors do
  use Ecto.Migration

  def change do
    create table(:actors, primary_key: false) do
      add :id, :bigint, primary_key: true
      add :domain, :string
      add :ap_id, :string, null: false
      add :type, :string, null: false
      add :following, :string, null: false
      add :followers, :string, null: false
      add :inbox, :string, null: false
      add :outbox, :string, null: false
      add :featured, :string
      add :featuredTags, :string
      add :preferredUsername, :string, null: false
      add :name, :string
      add :summary, :string
      add :url, :string
      add :manuallyApprovesFollowers, :boolean
      add :discoverable, :boolean, default: true
      add :indexable, :boolean, default: true
      add :published, :utc_datetime
      add :memorial, :boolean, default: false
      add :publicKey, :map
      add :tag, {:array, :map}, default: []
      add :attachment, {:array, :map}, default: []
      add :endpoints, :map
      add :icon, :map
      add :image, :map
      add :vcard_bday, :date
      add :vcard_Address, :string
    end
  end
end
