defmodule Nulla.Repo.Migrations.CreateNotifications do
  use Ecto.Migration

  def change do
    create table(:notifications, primary_key: false) do
      add :id, :bigint, primary_key: true
      add :user_id, references(:users, on_delete: :delete_all), null: false
      add :actor_id, references(:actors, on_delete: :nilify_all)
      add :type, :string, null: false
      add :data, :map
      add :read, :boolean, default: false, null: false

      timestamps()
    end

    create index(:notifications, [:user_id])
    create index(:notifications, [:actor_id])
  end
end
